/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.preparser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.preparser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITION_FILE; break;
                                case 3: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.DEFINITION_FILE; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TCommentContent(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TLineComment(text, line, pos); }
    Token new4(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TOtherClauseBegin(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TEndMachine(text, line, pos); }
    Token new7(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TKwPrefix(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TNoDefSomething(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new11(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new12(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TSlash(text, line, pos); }
    Token new14(  int line,   int pos) { return new TComma(line, pos); }
    Token new15(  int line,   int pos) { return new TBeginDefBody(line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TRhsBody(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TBeginNesting(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TEndNesting(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TRhsIdentifier(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TSemicolon(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TDoubleQuotation(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TFilename(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TSomething(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 35, 4}, {36, 46, 2}, {47, 47, 5}, {48, 64, 2}, {65, 65, 6}, {66, 66, 2}, {67, 67, 7}, {68, 68, 8}, {69, 69, 9}, {70, 72, 2}, {73, 73, 10}, {74, 75, 2}, {76, 76, 11}, {77, 77, 12}, {78, 78, 2}, {79, 79, 13}, {80, 80, 14}, {81, 81, 2}, {82, 82, 15}, {83, 83, 16}, {84, 84, 2}, {85, 85, 17}, {86, 86, 18}, {87, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 19}, {127, 160, 19}, {8206, 8207, 19}, {8232, 8233, 19}, },
            {},
            {{0, 33, 20}, {34, 34, 21}, {35, 91, 20}, {92, 92, 22}, {93, 65535, 20}, },
            {{65, 65, 23}, {67, 67, 24}, {68, 68, 25}, {69, 69, 26}, {73, 73, 27}, {76, 76, 28}, {79, 79, 29}, {80, 80, 30}, {82, 82, 31}, {83, 83, 32}, {85, 85, 33}, {86, 86, 34}, },
            {{42, 42, 35}, {47, 47, 36}, },
            {{66, 66, 37}, {83, 83, 38}, },
            {{79, 79, 39}, },
            {{69, 69, 40}, },
            {{78, 78, 41}, {86, 86, 42}, {88, 88, 43}, },
            {{77, 77, 44}, {78, 78, 45}, },
            {{79, 79, 46}, },
            {{65, 65, 47}, {79, 79, 48}, },
            {{80, 80, 49}, },
            {{82, 82, 50}, },
            {{69, 69, 51}, },
            {{69, 69, 52}, {89, 89, 53}, },
            {{83, 83, 54}, },
            {{65, 65, 55}, },
            {{0, 8233, -3}, },
            {{0, 65535, -5}, },
            {},
            {{0, 33, 20}, {34, 34, 56}, {35, 65535, -5}, },
            {{66, 66, 57}, {83, 83, 58}, },
            {{79, 79, 59}, },
            {{69, 69, 60}, },
            {{86, 86, 61}, {88, 88, 62}, },
            {{77, 77, 63}, {78, 78, 64}, },
            {{79, 79, 65}, },
            {{80, 80, 66}, },
            {{82, 82, 67}, },
            {{69, 69, 68}, },
            {{69, 69, 69}, {85, 85, 70}, },
            {{83, 83, 71}, },
            {{65, 65, 72}, },
            {},
            {{0, 9, 73}, {10, 10, 74}, {11, 12, 73}, {13, 13, 74}, {14, 65535, 73}, },
            {{83, 83, 75}, },
            {{83, 83, 76}, },
            {{78, 78, 77}, },
            {{70, 70, 78}, },
            {{68, 68, 79}, },
            {{69, 69, 80}, },
            {{84, 84, 81}, },
            {{80, 80, 82}, },
            {{67, 67, 83}, {73, 73, 84}, {86, 86, 85}, },
            {{67, 67, 86}, },
            {{67, 67, 87}, },
            {{68, 68, 88}, },
            {{69, 69, 89}, },
            {{79, 79, 90}, },
            {{70, 70, 91}, },
            {{69, 69, 92}, {84, 84, 93}, },
            {{83, 83, 94}, },
            {{69, 69, 95}, },
            {{76, 76, 96}, {82, 82, 97}, },
            {{0, 65535, -5}, },
            {{83, 83, 98}, },
            {{83, 83, 99}, },
            {{78, 78, 100}, },
            {{70, 70, 101}, },
            {{69, 69, 102}, },
            {{80, 80, 103}, },
            {{80, 80, 104}, },
            {{67, 67, 105}, {73, 73, 106}, {86, 86, 107}, },
            {{67, 67, 108}, },
            {{69, 69, 109}, },
            {{69, 69, 110}, {79, 79, 111}, },
            {{70, 70, 112}, },
            {{69, 69, 113}, {84, 84, 114}, },
            {{66, 66, 115}, },
            {{69, 69, 116}, },
            {{76, 76, 117}, {82, 82, 118}, },
            {{0, 65535, -38}, },
            {},
            {{84, 84, 119}, },
            {{69, 69, 120}, },
            {{67, 67, 121}, {83, 83, 122}, },
            {{73, 73, 123}, },
            {},
            {{78, 78, 124}, },
            {{69, 69, 125}, },
            {{76, 76, 126}, {79, 79, 127}, },
            {{76, 76, 128}, },
            {{84, 84, 129}, },
            {{65, 65, 130}, },
            {{65, 65, 131}, },
            {{72, 72, 132}, },
            {{69, 69, 133}, },
            {{82, 82, 134}, },
            {{77, 77, 135}, {80, 80, 136}, },
            {{73, 73, 137}, },
            {{83, 83, 138}, },
            {{83, 83, 139}, },
            {{84, 84, 140}, },
            {{83, 83, 141}, },
            {{85, 85, 142}, },
            {{73, 73, 143}, },
            {{84, 84, 144}, },
            {{69, 69, 145}, },
            {{67, 67, 146}, {83, 83, 147}, },
            {{73, 73, 148}, },
            {{78, 78, 149}, },
            {{82, 82, 150}, },
            {{76, 76, 151}, {79, 79, 152}, },
            {{76, 76, 153}, },
            {{84, 84, 154}, },
            {{65, 65, 155}, },
            {{65, 65, 156}, },
            {{82, 82, 157}, },
            {{68, 68, 158}, },
            {{77, 77, 159}, {80, 80, 160}, },
            {{73, 73, 161}, },
            {{83, 83, 162}, },
            {{83, 83, 163}, },
            {{83, 83, 164}, },
            {{83, 83, 165}, },
            {{85, 85, 166}, },
            {{73, 73, 167}, },
            {{82, 82, 168}, },
            {{82, 82, 169}, },
            {{82, 82, 170}, },
            {{84, 84, 171}, },
            {{78, 78, 172}, },
            {{84, 84, 173}, },
            {{78, 78, 174}, },
            {{69, 69, 175}, },
            {{82, 82, 176}, },
            {{85, 85, 177}, },
            {{73, 73, 178}, },
            {{82, 82, 179}, },
            {{76, 76, 180}, },
            {{73, 73, 181}, },
            {{76, 76, 182}, },
            {{65, 65, 183}, },
            {{79, 79, 184}, },
            {{69, 69, 185}, },
            {{78, 78, 186}, },
            {},
            {},
            {{69, 69, 187}, },
            {},
            {{69, 69, 188}, },
            {{65, 65, 189}, },
            {{82, 82, 190}, },
            {{82, 82, 191}, },
            {{82, 82, 192}, },
            {{84, 84, 193}, },
            {{78, 78, 194}, },
            {{84, 84, 195}, },
            {{69, 69, 196}, },
            {{69, 69, 197}, },
            {{82, 82, 198}, },
            {{85, 85, 199}, },
            {{73, 73, 200}, },
            {{82, 82, 201}, },
            {{76, 76, 202}, },
            {{65, 65, 203}, },
            {{73, 73, 204}, },
            {{79, 79, 205}, },
            {{69, 69, 206}, },
            {{78, 78, 207}, },
            {},
            {},
            {{84, 84, 208}, },
            {},
            {{69, 69, 209}, },
            {{65, 65, 210}, },
            {{65, 65, 211}, },
            {{84, 84, 212}, },
            {{69, 69, 213}, },
            {{65, 65, 214}, {82, 82, 215}, },
            {{73, 73, 216}, },
            {{83, 83, 217}, },
            {{68, 68, 218}, },
            {{77, 77, 219}, },
            {{84, 84, 220}, },
            {{68, 68, 221}, },
            {{65, 65, 222}, },
            {{73, 73, 223}, },
            {{95, 95, 224}, },
            {{78, 78, 225}, },
            {},
            {{84, 84, 226}, },
            {{84, 84, 227}, },
            {{82, 82, 228}, },
            {{69, 69, 229}, },
            {{77, 77, 230}, },
            {{83, 83, 231}, },
            {{66, 66, 232}, },
            {{65, 65, 233}, },
            {{84, 84, 234}, },
            {{69, 69, 235}, },
            {{65, 65, 236}, {82, 82, 237}, },
            {{73, 73, 238}, },
            {{83, 83, 239}, },
            {{83, 83, 240}, },
            {{77, 77, 241}, },
            {{84, 84, 242}, },
            {{68, 68, 243}, },
            {{65, 65, 244}, },
            {{73, 73, 245}, },
            {{95, 95, 246}, },
            {{84, 84, 247}, },
            {{67, 67, 248}, },
            {{84, 84, 249}, },
            {{82, 82, 250}, },
            {{69, 69, 251}, },
            {{73, 73, 252}, },
            {{83, 83, 253}, },
            {{66, 66, 254}, },
            {{67, 67, 255}, },
            {{73, 73, 256}, },
            {{84, 84, 257}, },
            {{78, 78, 258}, },
            {{65, 65, 259}, },
            {{84, 84, 260}, },
            {},
            {{83, 83, 261}, },
            {{69, 69, 262}, },
            {{83, 83, 263}, },
            {{69, 69, 264}, },
            {{76, 76, 265}, },
            {{65, 65, 266}, },
            {{79, 79, 267}, },
            {{69, 69, 268}, },
            {{73, 73, 269}, },
            {{69, 69, 270}, },
            {{84, 84, 271}, },
            {{77, 77, 272}, {83, 83, 273}, },
            {},
            {},
            {{76, 76, 274}, },
            {{67, 67, 275}, },
            {{73, 73, 276}, },
            {{84, 84, 277}, },
            {{78, 78, 278}, },
            {{65, 65, 279}, },
            {{84, 84, 280}, },
            {},
            {{83, 83, 281}, },
            {{69, 69, 282}, },
            {{83, 83, 283}, },
            {{69, 69, 284}, },
            {{76, 76, 285}, },
            {{65, 65, 286}, },
            {{79, 79, 287}, },
            {{73, 73, 288}, },
            {{65, 65, 289}, },
            {{69, 69, 290}, },
            {{84, 84, 291}, },
            {{83, 83, 292}, },
            {{84, 84, 293}, },
            {},
            {{76, 76, 294}, },
            {{84, 84, 295}, },
            {{79, 79, 296}, },
            {{69, 69, 297}, },
            {{84, 84, 298}, },
            {{73, 73, 299}, },
            {{73, 73, 300}, },
            {},
            {{78, 78, 301}, },
            {},
            {{83, 83, 302}, },
            {{73, 73, 303}, },
            {{78, 78, 304}, },
            {{80, 80, 305}, },
            {},
            {{79, 79, 306}, },
            {{83, 83, 307}, },
            {{73, 73, 308}, },
            {{69, 69, 309}, },
            {},
            {{69, 69, 310}, },
            {{84, 84, 311}, },
            {{79, 79, 312}, },
            {{69, 69, 313}, },
            {{84, 84, 314}, },
            {{73, 73, 315}, },
            {{73, 73, 316}, },
            {{73, 73, 317}, },
            {{78, 78, 318}, },
            {},
            {{83, 83, 319}, },
            {{73, 73, 320}, },
            {{78, 78, 321}, },
            {{80, 80, 322}, },
            {{79, 79, 323}, },
            {{84, 84, 324}, },
            {{83, 83, 325}, },
            {{73, 73, 326}, },
            {},
            {{85, 85, 327}, },
            {{69, 69, 328}, },
            {{95, 95, 329}, },
            {{78, 78, 330}, },
            {{95, 95, 331}, },
            {{83, 83, 332}, },
            {{78, 78, 333}, },
            {{79, 79, 334}, },
            {{84, 84, 335}, },
            {},
            {{83, 83, 336}, {90, 90, 337}, },
            {{84, 84, 338}, },
            {{69, 69, 339}, },
            {{78, 78, 340}, },
            {},
            {{69, 69, 341}, },
            {{78, 78, 342}, },
            {{83, 83, 343}, },
            {{95, 95, 344}, },
            {{78, 78, 345}, },
            {{95, 95, 346}, },
            {{83, 83, 347}, },
            {{78, 78, 348}, },
            {{79, 79, 349}, },
            {{79, 79, 350}, },
            {{84, 84, 351}, },
            {},
            {{83, 83, 352}, {90, 90, 353}, },
            {{84, 84, 354}, },
            {{69, 69, 355}, },
            {{78, 78, 356}, },
            {{69, 69, 357}, },
            {},
            {{69, 69, 358}, },
            {{84, 84, 359}, },
            {{83, 83, 360}, },
            {{67, 67, 361}, {86, 86, 362}, },
            {{83, 83, 363}, },
            {{67, 67, 364}, {86, 86, 365}, },
            {},
            {{84, 84, 366}, },
            {{78, 78, 367}, },
            {{65, 65, 368}, },
            {{65, 65, 369}, },
            {{65, 65, 370}, },
            {},
            {{82, 82, 371}, },
            {{83, 83, 372}, },
            {{83, 83, 373}, },
            {{84, 84, 374}, },
            {},
            {{67, 67, 375}, {86, 86, 376}, },
            {{83, 83, 377}, },
            {{67, 67, 378}, {86, 86, 379}, },
            {},
            {{84, 84, 380}, },
            {{78, 78, 381}, },
            {{78, 78, 382}, },
            {{65, 65, 383}, },
            {{65, 65, 384}, },
            {{65, 65, 385}, },
            {},
            {{82, 82, 386}, },
            {{83, 83, 387}, },
            {},
            {{83, 83, 388}, },
            {{73, 73, 389}, },
            {},
            {{79, 79, 390}, },
            {{65, 65, 391}, },
            {},
            {{79, 79, 392}, },
            {{65, 65, 393}, },
            {{83, 83, 394}, },
            {{83, 83, 395}, },
            {{84, 84, 396}, },
            {{84, 84, 397}, },
            {{84, 84, 398}, },
            {{65, 65, 399}, },
            {},
            {},
            {},
            {{79, 79, 400}, },
            {{65, 65, 401}, },
            {},
            {{79, 79, 402}, },
            {{65, 65, 403}, },
            {{83, 83, 404}, },
            {{83, 83, 405}, },
            {},
            {{84, 84, 406}, },
            {{84, 84, 407}, },
            {{84, 84, 408}, },
            {{65, 65, 409}, },
            {},
            {},
            {{79, 79, 410}, },
            {{78, 78, 411}, },
            {{82, 82, 412}, },
            {{78, 78, 413}, },
            {{82, 82, 414}, },
            {},
            {},
            {{73, 73, 415}, },
            {{73, 73, 416}, },
            {{73, 73, 417}, },
            {{84, 84, 418}, },
            {{78, 78, 419}, },
            {{82, 82, 420}, },
            {{78, 78, 421}, },
            {{82, 82, 422}, },
            {},
            {},
            {{73, 73, 423}, },
            {{73, 73, 424}, },
            {{73, 73, 425}, },
            {{84, 84, 426}, },
            {{78, 78, 427}, },
            {{83, 83, 428}, },
            {{73, 73, 429}, },
            {{83, 83, 430}, },
            {{73, 73, 431}, },
            {{79, 79, 432}, },
            {{79, 79, 433}, },
            {{79, 79, 434}, },
            {{73, 73, 435}, },
            {{83, 83, 436}, },
            {{73, 73, 437}, },
            {{83, 83, 438}, },
            {{73, 73, 439}, },
            {{79, 79, 440}, },
            {{79, 79, 441}, },
            {{79, 79, 442}, },
            {{73, 73, 443}, },
            {},
            {{84, 84, 444}, },
            {{65, 65, 445}, },
            {{84, 84, 446}, },
            {{65, 65, 447}, },
            {{78, 78, 448}, },
            {{78, 78, 449}, },
            {{78, 78, 450}, },
            {{79, 79, 451}, },
            {{84, 84, 452}, },
            {{65, 65, 453}, },
            {{84, 84, 454}, },
            {{65, 65, 455}, },
            {{78, 78, 456}, },
            {{78, 78, 457}, },
            {{78, 78, 458}, },
            {{79, 79, 459}, },
            {{65, 65, 460}, },
            {{66, 66, 461}, },
            {{65, 65, 462}, },
            {{66, 66, 463}, },
            {},
            {},
            {},
            {{78, 78, 464}, },
            {{65, 65, 465}, },
            {{66, 66, 466}, },
            {{65, 65, 467}, },
            {{66, 66, 468}, },
            {},
            {},
            {},
            {{78, 78, 469}, },
            {{78, 78, 470}, },
            {{76, 76, 471}, },
            {{78, 78, 472}, },
            {{76, 76, 473}, },
            {{83, 83, 474}, },
            {{78, 78, 475}, },
            {{76, 76, 476}, },
            {{78, 78, 477}, },
            {{76, 76, 478}, },
            {{83, 83, 479}, },
            {{84, 84, 480}, },
            {{69, 69, 481}, },
            {{84, 84, 482}, },
            {{69, 69, 483}, },
            {},
            {{84, 84, 484}, },
            {{69, 69, 485}, },
            {{84, 84, 486}, },
            {{69, 69, 487}, },
            {},
            {{83, 83, 488}, },
            {{83, 83, 489}, },
            {{83, 83, 490}, },
            {{83, 83, 491}, },
            {{83, 83, 492}, },
            {{83, 83, 493}, },
            {{83, 83, 494}, },
            {{83, 83, 495}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
        }
        { // DEFINITIONS
            {{0, 32, 1}, {34, 34, 2}, {40, 40, 3}, {41, 41, 4}, {44, 44, 5}, {47, 47, 6}, {59, 59, 7}, {61, 61, 8}, {65, 65, 9}, {66, 66, 10}, {67, 67, 11}, {68, 68, 10}, {69, 69, 12}, {70, 72, 10}, {73, 73, 13}, {74, 75, 10}, {76, 76, 14}, {77, 77, 15}, {78, 78, 10}, {79, 79, 16}, {80, 80, 17}, {81, 81, 10}, {82, 82, 18}, {83, 83, 19}, {84, 84, 10}, {85, 85, 20}, {86, 86, 21}, {87, 90, 10}, {97, 122, 22}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 32, 1}, {127, 8233, -2}, },
            {},
            {},
            {},
            {},
            {{42, 42, 23}, {47, 47, 24}, },
            {},
            {{61, 61, 25}, },
            {{48, 57, 26}, {65, 65, 27}, {66, 66, 28}, {67, 82, 27}, {83, 83, 29}, {84, 90, 27}, {95, 95, 30}, {97, 122, 31}, },
            {{48, 57, 26}, {65, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 78, 27}, {79, 79, 32}, {80, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 77, 27}, {78, 78, 33}, {79, 85, 27}, {86, 86, 34}, {87, 87, 27}, {88, 88, 35}, {89, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 76, 27}, {77, 77, 36}, {78, 78, 37}, {79, 90, 27}, {95, 122, -11}, },
            {{48, 78, -13}, {79, 79, 38}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 39}, {66, 78, 27}, {79, 79, 40}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 79, 27}, {80, 80, 41}, {81, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 81, 27}, {82, 82, 42}, {83, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 68, 27}, {69, 69, 43}, {70, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 44}, {70, 88, 27}, {89, 89, 45}, {90, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 82, 27}, {83, 83, 46}, {84, 122, -11}, },
            {{48, 57, 26}, {65, 65, 47}, {66, 90, 27}, {95, 122, -11}, },
            {{48, 122, -12}, },
            {},
            {{0, 9, 48}, {10, 10, 49}, {11, 12, 48}, {13, 13, 49}, {14, 65535, 48}, },
            {},
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 50}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 51}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 52}, {79, 122, -15}, },
            {{48, 57, 26}, {65, 67, 27}, {68, 68, 53}, {69, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 54}, {70, 122, -20}, },
            {{48, 57, 26}, {65, 83, 27}, {84, 84, 55}, {85, 90, 27}, {95, 122, -11}, },
            {{48, 79, -18}, {80, 80, 56}, {81, 122, -18}, },
            {{48, 57, 26}, {65, 66, 27}, {67, 67, 57}, {68, 72, 27}, {73, 73, 58}, {74, 85, 27}, {86, 86, 59}, {87, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 60}, {68, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 61}, {68, 122, -40}, },
            {{48, 67, -35}, {68, 68, 62}, {69, 122, -35}, },
            {{48, 68, -20}, {69, 69, 63}, {70, 122, -20}, },
            {{48, 78, -13}, {79, 79, 64}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 69, 27}, {70, 70, 65}, {71, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 66}, {70, 83, 27}, {84, 84, 67}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 68}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 69}, {70, 122, -20}, },
            {{48, 57, 26}, {65, 75, 27}, {76, 76, 70}, {77, 81, 27}, {82, 82, 71}, {83, 122, -19}, },
            {{0, 65535, -26}, },
            {},
            {{48, 83, -37}, {84, 84, 72}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 73}, {70, 122, -20}, },
            {{48, 66, -39}, {67, 67, 74}, {68, 82, 27}, {83, 83, 75}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 76}, {79, 122, -15}, },
            {{48, 68, -20}, {69, 69, 77}, {70, 122, -20}, },
            {{48, 75, -49}, {76, 76, 78}, {77, 78, 27}, {79, 79, 79}, {80, 122, -13}, },
            {{48, 75, -49}, {76, 76, 80}, {77, 90, 27}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 81}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 82}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 83}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 71, 27}, {72, 72, 84}, {73, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 85}, {70, 122, -20}, },
            {{48, 81, -19}, {82, 82, 86}, {83, 122, -19}, },
            {{48, 76, -15}, {77, 77, 87}, {78, 79, 27}, {80, 80, 88}, {81, 122, -18}, },
            {{48, 57, 26}, {65, 72, 27}, {73, 73, 89}, {74, 90, 27}, {95, 122, -11}, },
            {{48, 82, -22}, {83, 83, 90}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 91}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 92}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 93}, {84, 122, -11}, },
            {{48, 57, 26}, {65, 84, 27}, {85, 85, 94}, {86, 90, 27}, {95, 122, -11}, },
            {{48, 72, -67}, {73, 73, 95}, {74, 122, -67}, },
            {{48, 81, -19}, {82, 82, 96}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 97}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 98}, {83, 122, -19}, },
            {{48, 83, -37}, {84, 84, 99}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 100}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 101}, {79, 122, -15}, },
            {{48, 68, -20}, {69, 69, 102}, {70, 122, -20}, },
            {{48, 81, -19}, {82, 82, 103}, {83, 122, -19}, },
            {{48, 84, -72}, {85, 85, 104}, {86, 122, -72}, },
            {{48, 72, -67}, {73, 73, 105}, {74, 122, -67}, },
            {{48, 81, -19}, {82, 82, 106}, {83, 122, -19}, },
            {{48, 75, -49}, {76, 76, 107}, {77, 122, -59}, },
            {{48, 72, -67}, {73, 73, 108}, {74, 122, -67}, },
            {{48, 75, -49}, {76, 76, 109}, {77, 122, -59}, },
            {{48, 57, 26}, {65, 65, 110}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 111}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 112}, {70, 122, -20}, },
            {{48, 77, -14}, {78, 78, 113}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 114}, {70, 122, -20}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 115}, {70, 122, -20}, },
            {{48, 57, 26}, {65, 65, 116}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 117}, {66, 122, -23}, },
            {{48, 83, -37}, {84, 84, 118}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 119}, {70, 122, -20}, },
            {{48, 57, 26}, {65, 65, 120}, {66, 81, 27}, {82, 82, 121}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 122}, {84, 122, -11}, },
            {{48, 67, -35}, {68, 68, 123}, {69, 122, -35}, },
            {{48, 76, -15}, {77, 77, 124}, {78, 90, 27}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 125}, {85, 122, -37}, },
            {{48, 67, -35}, {68, 68, 126}, {69, 122, -35}, },
            {{48, 57, 26}, {65, 65, 127}, {66, 122, -23}, },
            {{48, 72, -67}, {73, 73, 128}, {74, 122, -67}, },
            {{48, 90, -12}, {95, 95, 129}, {97, 122, 31}, },
            {{48, 77, -14}, {78, 78, 130}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 83, -37}, {84, 84, 131}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 132}, {85, 122, -37}, },
            {{48, 81, -19}, {82, 82, 133}, {83, 122, -19}, },
            {{48, 68, -20}, {69, 69, 134}, {70, 122, -20}, },
            {{48, 76, -15}, {77, 77, 135}, {78, 122, -104}, },
            {{48, 82, -22}, {83, 83, 136}, {84, 122, -11}, },
            {{48, 65, -11}, {66, 66, 137}, {67, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 138}, {68, 122, -40}, },
            {{48, 72, -67}, {73, 73, 139}, {74, 122, -67}, },
            {{48, 83, -37}, {84, 84, 140}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 141}, {79, 122, -15}, },
            {{48, 57, 26}, {65, 65, 142}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 143}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 144}, {70, 122, -20}, },
            {{48, 82, -22}, {83, 83, 145}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 146}, {70, 122, -20}, },
            {{48, 75, -49}, {76, 76, 147}, {77, 122, -59}, },
            {{48, 57, 26}, {65, 65, 148}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 149}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 150}, {70, 122, -20}, },
            {{48, 72, -67}, {73, 73, 151}, {74, 122, -67}, },
            {{48, 68, -20}, {69, 69, 152}, {70, 122, -20}, },
            {{48, 83, -37}, {84, 84, 153}, {85, 122, -37}, },
            {{48, 76, -15}, {77, 77, 154}, {78, 82, 27}, {83, 83, 155}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 75, -49}, {76, 76, 156}, {77, 122, -59}, },
            {{48, 83, -37}, {84, 84, 157}, {85, 122, -37}, },
            {{48, 78, -13}, {79, 79, 158}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 159}, {70, 122, -20}, },
            {{48, 83, -37}, {84, 84, 160}, {85, 122, -37}, },
            {{48, 72, -67}, {73, 73, 161}, {74, 122, -67}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 162}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 163}, {84, 122, -11}, },
            {{48, 72, -67}, {73, 73, 164}, {74, 122, -67}, },
            {{48, 77, -14}, {78, 78, 165}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 166}, {81, 122, -18}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 167}, {80, 122, -13}, },
            {{48, 82, -22}, {83, 83, 168}, {84, 122, -11}, },
            {{48, 72, -67}, {73, 73, 169}, {74, 122, -67}, },
            {{48, 68, -20}, {69, 69, 170}, {70, 122, -20}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 171}, {70, 122, -20}, },
            {{48, 90, -12}, {95, 95, 172}, {97, 122, 31}, },
            {{48, 77, -14}, {78, 78, 173}, {79, 122, -15}, },
            {{48, 90, -12}, {95, 95, 174}, {97, 122, 31}, },
            {{48, 82, -22}, {83, 83, 175}, {84, 122, -11}, },
            {{48, 77, -14}, {78, 78, 176}, {79, 122, -15}, },
            {{48, 83, -37}, {84, 84, 177}, {85, 122, -37}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 178}, {84, 89, 27}, {90, 90, 179}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 180}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 181}, {70, 122, -20}, },
            {{48, 77, -14}, {78, 78, 182}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 183}, {70, 122, -20}, },
            {{48, 77, -14}, {78, 78, 184}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 185}, {84, 122, -11}, },
            {{48, 66, -39}, {67, 67, 186}, {68, 85, 27}, {86, 86, 187}, {87, 122, -39}, },
            {{48, 82, -22}, {83, 83, 188}, {84, 122, -11}, },
            {{48, 66, -39}, {67, 67, 189}, {68, 85, 27}, {86, 86, 190}, {87, 122, -39}, },
            {{48, 122, -12}, },
            {{48, 83, -37}, {84, 84, 191}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 192}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 193}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 194}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 81, -19}, {82, 82, 195}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 196}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 197}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 198}, {85, 122, -37}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 199}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 200}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 201}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 202}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 203}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 204}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 205}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 206}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 207}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 208}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 209}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 210}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 211}, {83, 122, -19}, },
            {{48, 122, -12}, },
            {{48, 72, -67}, {73, 73, 212}, {74, 122, -67}, },
            {{48, 72, -67}, {73, 73, 213}, {74, 122, -67}, },
            {{48, 72, -67}, {73, 73, 214}, {74, 122, -67}, },
            {{48, 83, -37}, {84, 84, 215}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 216}, {84, 122, -11}, },
            {{48, 72, -67}, {73, 73, 217}, {74, 122, -67}, },
            {{48, 82, -22}, {83, 83, 218}, {84, 122, -11}, },
            {{48, 72, -67}, {73, 73, 219}, {74, 122, -67}, },
            {{48, 78, -13}, {79, 79, 220}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 221}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 222}, {80, 122, -13}, },
            {{48, 72, -67}, {73, 73, 223}, {74, 122, -67}, },
            {{48, 83, -37}, {84, 84, 224}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 225}, {66, 122, -23}, },
            {{48, 83, -37}, {84, 84, 226}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 227}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 228}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 229}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 230}, {79, 122, -15}, },
            {{48, 78, -13}, {79, 79, 231}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 232}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 233}, {67, 122, -118}, },
            {{48, 57, 26}, {65, 65, 234}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 235}, {67, 122, -118}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 236}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 237}, {79, 122, -15}, },
            {{48, 75, -49}, {76, 76, 238}, {77, 122, -59}, },
            {{48, 77, -14}, {78, 78, 239}, {79, 122, -15}, },
            {{48, 75, -49}, {76, 76, 240}, {77, 122, -59}, },
            {{48, 82, -22}, {83, 83, 241}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 242}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 243}, {70, 122, -20}, },
            {{48, 83, -37}, {84, 84, 244}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 245}, {70, 122, -20}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 246}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 247}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 248}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 249}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
        }
        { // DEFINITIONS_RHS
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 39, 2}, {40, 40, 4}, {41, 41, 5}, {42, 46, 2}, {47, 47, 6}, {48, 58, 2}, {59, 59, 7}, {60, 64, 2}, {65, 65, 8}, {66, 66, 9}, {67, 67, 10}, {68, 68, 11}, {69, 69, 12}, {70, 72, 11}, {73, 73, 13}, {74, 75, 11}, {76, 76, 14}, {77, 77, 15}, {78, 78, 11}, {79, 79, 16}, {80, 80, 17}, {81, 81, 11}, {82, 82, 18}, {83, 83, 19}, {84, 84, 11}, {85, 85, 20}, {86, 86, 21}, {87, 87, 22}, {88, 90, 11}, {91, 96, 2}, {97, 122, 23}, {123, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {{0, 33, 24}, {34, 34, 25}, {35, 91, 24}, {92, 92, 26}, {93, 65535, 24}, },
            {},
            {},
            {{42, 42, 27}, {47, 47, 28}, },
            {},
            {{48, 57, 29}, {65, 65, 30}, {66, 66, 31}, {67, 77, 30}, {78, 78, 32}, {79, 82, 30}, {83, 83, 33}, {84, 90, 30}, {95, 95, 34}, {97, 122, 35}, },
            {{48, 57, 29}, {65, 68, 30}, {69, 69, 36}, {70, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 65, 37}, {66, 71, 30}, {72, 72, 38}, {73, 78, 30}, {79, 79, 39}, {80, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 77, 30}, {78, 78, 40}, {79, 85, 30}, {86, 86, 41}, {87, 87, 30}, {88, 88, 42}, {89, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 69, 30}, {70, 70, 43}, {71, 76, 30}, {77, 77, 44}, {78, 78, 45}, {79, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 46}, {70, 78, 30}, {79, 79, 47}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 48}, {66, 78, 30}, {79, 79, 49}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 79, 30}, {80, 80, 50}, {81, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 81, 30}, {82, 82, 51}, {83, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 52}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 53}, {70, 88, 30}, {89, 89, 54}, {90, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 82, 30}, {83, 83, 55}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 65, 56}, {66, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 71, 30}, {72, 72, 57}, {73, 90, 30}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{0, 65535, -5}, },
            {},
            {{0, 33, 24}, {34, 34, 58}, {35, 65535, -5}, },
            {},
            {{0, 9, 59}, {10, 10, 60}, {11, 12, 59}, {13, 13, 60}, {14, 65535, 59}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 61}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 88, 30}, {89, 89, 62}, {90, 122, -21}, },
            {{48, 82, -22}, {83, 83, 63}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 70, 30}, {71, 71, 64}, {72, 90, 30}, {95, 122, -10}, },
            {{48, 82, -22}, {83, 83, 65}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 78, 30}, {79, 79, 66}, {80, 122, -12}, },
            {{48, 77, -14}, {78, 78, 67}, {79, 122, -15}, },
            {{48, 57, 29}, {65, 67, 30}, {68, 68, 68}, {69, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 69}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 83, 30}, {84, 84, 70}, {85, 90, 30}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 79, -18}, {80, 80, 71}, {81, 122, -18}, },
            {{48, 57, 29}, {65, 66, 30}, {67, 67, 72}, {68, 72, 30}, {73, 73, 73}, {74, 85, 30}, {86, 86, 74}, {87, 90, 30}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 75}, {85, 122, -44}, },
            {{48, 66, -47}, {67, 67, 76}, {68, 90, 30}, {95, 122, -10}, },
            {{48, 66, -47}, {67, 67, 77}, {68, 122, -49}, },
            {{48, 67, -42}, {68, 68, 78}, {69, 122, -42}, },
            {{48, 68, -11}, {69, 69, 79}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 80}, {70, 78, 30}, {79, 79, 81}, {80, 122, -12}, },
            {{48, 69, -15}, {70, 70, 82}, {71, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 83}, {70, 75, 30}, {76, 76, 84}, {77, 83, 30}, {84, 84, 85}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 86}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 87}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 75, 30}, {76, 76, 88}, {77, 81, 30}, {82, 82, 89}, {83, 122, -19}, },
            {{48, 57, 29}, {65, 72, 30}, {73, 73, 90}, {74, 90, 30}, {95, 122, -10}, },
            {{0, 65535, -5}, },
            {{0, 65535, -30}, },
            {},
            {{48, 83, -44}, {84, 84, 91}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 92}, {70, 122, -11}, },
            {{48, 72, -59}, {73, 73, 93}, {74, 122, -59}, },
            {{48, 68, -11}, {69, 69, 94}, {70, 122, -11}, },
            {{48, 72, -59}, {73, 73, 95}, {74, 122, -59}, },
            {{48, 66, -47}, {67, 67, 96}, {68, 82, 30}, {83, 83, 97}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 98}, {79, 122, -15}, },
            {{48, 68, -11}, {69, 69, 99}, {70, 122, -11}, },
            {{48, 75, -58}, {76, 76, 100}, {77, 78, 30}, {79, 79, 101}, {80, 122, -12}, },
            {{48, 75, -58}, {76, 76, 102}, {77, 90, 30}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 103}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 104}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 65, 105}, {66, 122, -23}, },
            {{48, 71, -24}, {72, 72, 106}, {73, 122, -24}, },
            {{48, 68, -11}, {69, 69, 107}, {70, 122, -11}, },
            {{48, 81, -19}, {82, 82, 108}, {83, 122, -19}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 76, 30}, {77, 77, 109}, {78, 79, 30}, {80, 80, 110}, {81, 122, -18}, },
            {{48, 72, -59}, {73, 73, 111}, {74, 122, -59}, },
            {{48, 82, -22}, {83, 83, 112}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 113}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 114}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 115}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 116}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 84, 30}, {85, 85, 117}, {86, 90, 30}, {95, 122, -10}, },
            {{48, 72, -59}, {73, 73, 118}, {74, 122, -59}, },
            {{48, 75, -58}, {76, 76, 119}, {77, 122, -74}, },
            {{48, 81, -19}, {82, 82, 120}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 121}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 122}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 66, -47}, {67, 67, 123}, {68, 122, -49}, },
            {{48, 81, -19}, {82, 82, 124}, {83, 122, -19}, },
            {{48, 83, -44}, {84, 84, 125}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 126}, {85, 122, -44}, },
            {{48, 77, -14}, {78, 78, 127}, {79, 122, -15}, },
            {{48, 68, -11}, {69, 69, 128}, {70, 122, -11}, },
            {{48, 81, -19}, {82, 82, 129}, {83, 122, -19}, },
            {{48, 84, -90}, {85, 85, 130}, {86, 122, -90}, },
            {{48, 72, -59}, {73, 73, 131}, {74, 122, -59}, },
            {{48, 81, -19}, {82, 82, 132}, {83, 122, -19}, },
            {{48, 75, -58}, {76, 76, 133}, {77, 122, -74}, },
            {{48, 72, -59}, {73, 73, 134}, {74, 122, -59}, },
            {{48, 75, -58}, {76, 76, 135}, {77, 122, -74}, },
            {{48, 57, 29}, {65, 65, 136}, {66, 122, -23}, },
            {{48, 78, -40}, {79, 79, 137}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 138}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 139}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 66, -47}, {67, 67, 140}, {68, 122, -49}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 141}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 142}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 65, 143}, {66, 122, -23}, },
            {{48, 68, -11}, {69, 69, 144}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 65, 145}, {66, 122, -23}, },
            {{48, 83, -44}, {84, 84, 146}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 147}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 148}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 65, 149}, {66, 81, 30}, {82, 82, 150}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 151}, {84, 122, -10}, },
            {{48, 67, -42}, {68, 68, 152}, {69, 122, -42}, },
            {{48, 76, -83}, {77, 77, 153}, {78, 90, 30}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 154}, {85, 122, -44}, },
            {{48, 67, -42}, {68, 68, 155}, {69, 122, -42}, },
            {{48, 57, 29}, {65, 65, 156}, {66, 122, -23}, },
            {{48, 72, -59}, {73, 73, 157}, {74, 122, -59}, },
            {{48, 90, -13}, {95, 95, 158}, {97, 122, 35}, },
            {{48, 77, -14}, {78, 78, 159}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 83, -44}, {84, 84, 160}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 161}, {85, 122, -44}, },
            {{48, 81, -19}, {82, 82, 162}, {83, 122, -19}, },
            {{48, 68, -11}, {69, 69, 163}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 164}, {85, 122, -44}, },
            {{48, 76, -83}, {77, 77, 165}, {78, 122, -130}, },
            {{48, 82, -22}, {83, 83, 166}, {84, 122, -10}, },
            {{48, 65, -10}, {66, 66, 167}, {67, 90, 30}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 66, -47}, {67, 67, 168}, {68, 122, -49}, },
            {{48, 72, -59}, {73, 73, 169}, {74, 122, -59}, },
            {{48, 122, -13}, },
            {{48, 83, -44}, {84, 84, 170}, {85, 122, -44}, },
            {{48, 77, -14}, {78, 78, 171}, {79, 122, -15}, },
            {{48, 57, 29}, {65, 65, 172}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 173}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 174}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 175}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 176}, {70, 122, -11}, },
            {{48, 75, -58}, {76, 76, 177}, {77, 122, -74}, },
            {{48, 57, 29}, {65, 65, 178}, {66, 122, -23}, },
            {{48, 78, -40}, {79, 79, 179}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 180}, {70, 122, -11}, },
            {{48, 72, -59}, {73, 73, 181}, {74, 122, -59}, },
            {{48, 68, -11}, {69, 69, 182}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 183}, {85, 122, -44}, },
            {{48, 76, -83}, {77, 77, 184}, {78, 82, 30}, {83, 83, 185}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 75, -58}, {76, 76, 186}, {77, 122, -74}, },
            {{48, 83, -44}, {84, 84, 187}, {85, 122, -44}, },
            {{48, 78, -40}, {79, 79, 188}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 189}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 190}, {85, 122, -44}, },
            {{48, 72, -59}, {73, 73, 191}, {74, 122, -59}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 192}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 193}, {84, 122, -10}, },
            {{48, 72, -59}, {73, 73, 194}, {74, 122, -59}, },
            {{48, 77, -14}, {78, 78, 195}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 196}, {81, 122, -18}, },
            {{48, 122, -13}, },
            {{48, 78, -40}, {79, 79, 197}, {80, 122, -12}, },
            {{48, 82, -22}, {83, 83, 198}, {84, 122, -10}, },
            {{48, 72, -59}, {73, 73, 199}, {74, 122, -59}, },
            {{48, 68, -11}, {69, 69, 200}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 201}, {70, 122, -11}, },
            {{48, 90, -13}, {95, 95, 202}, {97, 122, 35}, },
            {{48, 77, -14}, {78, 78, 203}, {79, 122, -15}, },
            {{48, 90, -13}, {95, 95, 204}, {97, 122, 35}, },
            {{48, 82, -22}, {83, 83, 205}, {84, 122, -10}, },
            {{48, 77, -14}, {78, 78, 206}, {79, 122, -15}, },
            {{48, 83, -44}, {84, 84, 207}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 208}, {84, 89, 30}, {90, 90, 209}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 210}, {85, 122, -44}, },
            {{48, 68, -11}, {69, 69, 211}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 212}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 213}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 214}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 215}, {84, 122, -10}, },
            {{48, 66, -47}, {67, 67, 216}, {68, 85, 30}, {86, 86, 217}, {87, 122, -47}, },
            {{48, 82, -22}, {83, 83, 218}, {84, 122, -10}, },
            {{48, 66, -47}, {67, 67, 219}, {68, 85, 30}, {86, 86, 220}, {87, 122, -47}, },
            {{48, 122, -13}, },
            {{48, 83, -44}, {84, 84, 221}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 222}, {66, 122, -23}, },
            {{48, 57, 29}, {65, 65, 223}, {66, 122, -23}, },
            {{48, 57, 29}, {65, 65, 224}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 81, -19}, {82, 82, 225}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 226}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 227}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 228}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 78, -40}, {79, 79, 229}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 230}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 78, -40}, {79, 79, 231}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 232}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 233}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 234}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 235}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 236}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 237}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 238}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 239}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 240}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 241}, {83, 122, -19}, },
            {{48, 122, -13}, },
            {{48, 72, -59}, {73, 73, 242}, {74, 122, -59}, },
            {{48, 72, -59}, {73, 73, 243}, {74, 122, -59}, },
            {{48, 72, -59}, {73, 73, 244}, {74, 122, -59}, },
            {{48, 83, -44}, {84, 84, 245}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 246}, {84, 122, -10}, },
            {{48, 72, -59}, {73, 73, 247}, {74, 122, -59}, },
            {{48, 82, -22}, {83, 83, 248}, {84, 122, -10}, },
            {{48, 72, -59}, {73, 73, 249}, {74, 122, -59}, },
            {{48, 78, -40}, {79, 79, 250}, {80, 122, -12}, },
            {{48, 78, -40}, {79, 79, 251}, {80, 122, -12}, },
            {{48, 78, -40}, {79, 79, 252}, {80, 122, -12}, },
            {{48, 72, -59}, {73, 73, 253}, {74, 122, -59}, },
            {{48, 83, -44}, {84, 84, 254}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 255}, {66, 122, -23}, },
            {{48, 83, -44}, {84, 84, 256}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 257}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 258}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 259}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 260}, {79, 122, -15}, },
            {{48, 78, -40}, {79, 79, 261}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 262}, {66, 122, -23}, },
            {{48, 65, -10}, {66, 66, 263}, {67, 122, -145}, },
            {{48, 57, 29}, {65, 65, 264}, {66, 122, -23}, },
            {{48, 65, -10}, {66, 66, 265}, {67, 122, -145}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 266}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 267}, {79, 122, -15}, },
            {{48, 75, -58}, {76, 76, 268}, {77, 122, -74}, },
            {{48, 77, -14}, {78, 78, 269}, {79, 122, -15}, },
            {{48, 75, -58}, {76, 76, 270}, {77, 122, -74}, },
            {{48, 82, -22}, {83, 83, 271}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 272}, {85, 122, -44}, },
            {{48, 68, -11}, {69, 69, 273}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 274}, {85, 122, -44}, },
            {{48, 68, -11}, {69, 69, 275}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 276}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 277}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 278}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 279}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
        }
        { // DEFINITION_FILE
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 33, -2}, {35, 65535, -2}, },
            {{0, 33, 2}, {35, 65535, 2}, },
            {},
        }
        { // NO_DEFINITIONS
            {{0, 32, 1}, {33, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 65535, -2}, },
            {{0, 65535, 2}, },
        }
        { // COMMENT
            {{0, 32, 1}, {33, 41, 2}, {42, 42, 3}, {43, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 4}, {127, 160, 4}, {8206, 8207, 4}, {8232, 8233, 4}, },
            {},
            {{47, 47, 5}, },
            {{0, 8233, -3}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 23, 23, -1, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 24, -1, 23, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 3, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 23, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 3, 3, -1, -1, -1, -1, 6, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, 5, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 8, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, 5, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, 5, -1, 5, -1, -1, -1, -1, 5, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, 5, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, 8, -1, -1, 8, -1, -1, 8, -1, -1, 5, -1, -1, -1, -1, -1, -1, -1, -1, 5, 5, 5, -1, -1, 8, -1, -1, -1, -1, 8, -1, -1, -1, -1, 8, 8, -1, -1, -1, -1, -1, 5, 4, -1, -1, -1, -1, -1, -1, -1, -1, 8, 7, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, 5, 5, -1, -1, -1, -1, -1, 8, 8, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 5, -1, -1, -1, -1, 8, -1, -1, -1, -1, -1, -1, -1, -1, 5, 5, 5, 5, 8, 8, 8, 8, },
        // DEFINITIONS
        {-1, 24, 21, 11, 12, 14, 13, 20, -1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 0, 3, 15, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 3, 3, 10, 10, 10, 6, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 5, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 5, 10, 10, 10, 10, 10, 10, 5, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 5, 5, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 5, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 5, 5, 5, },
        // DEFINITIONS_RHS
        {-1, 24, 16, -1, 11, 12, 13, 20, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, -1, 16, -1, 0, 3, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 16, 3, 3, 19, 17, 19, 19, 19, 19, 19, 18, 19, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 5, 19, 5, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 17, 19, 17, 17, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 17, 5, 5, 19, 19, 19, 19, 19, 19, 5, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 5, 5, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 5, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 5, 5, 5, },
        // DEFINITION_FILE
        {22, 22, 22, 21, },
        // NO_DEFINITIONS
        {9, 9, 9, },
        // COMMENT
        {-1, 2, 2, 2, 24, 1, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State DEFINITIONS = new State(1);
        public final static State DEFINITIONS_RHS = new State(2);
        public final static State DEFINITION_FILE = new State(3);
        public final static State NO_DEFINITIONS = new State(4);
        public final static State COMMENT = new State(5);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
